﻿//enable double clicking
#target photoshop
app.bringToFront();
//store document
var docRef = app.activeDocument;
//store active layer
var layerRef = docRef.activeLayer.typename;
//make sure a group is selected
if(layerRef == "LayerSet"){
	//if there is no layers outside the set - make one
	if(docRef.layers.length == 1){
		var groupRef = docRef.activeLayer;
		var newLayer = docRef.artLayers.add();
		newLayer.name = "white";
		//select all so we can apply a fill to the selection 
		docRef.selection.selectAll();
		//create a color to be used with the fill command 
		var colorRef = new SolidColor();
		colorRef.rgb.red = 255;
		colorRef.rgb.green = 255;
		colorRef.rgb.blue = 255;
		//fill the current selection 
		docRef.selection.fill(colorRef);
		//deselect selection
		docRef.selection.deselect();
		docRef.activeLayer = groupRef;
	}
	//move group to top
	docRef.activeLayer.move(docRef.layers[0],ElementPlacement.PLACEBEFORE);
	//get the amount of layers in the group
	groupLength = docRef.layerSets[0].layers.length;
	//cycle through the group layers
	for(var i = 0; i < groupLength; i ++){
		//get the layer's name
		var layerRef = docRef.layerSets[0].layers[0];
		var layerName = layerRef.name;
		//make sure the layer is visible
		layerRef.visible = true; 
		//check for a selection
		if(checkSelection(docRef)){
            //select all and copy to clipboard
            docRef.selection.selectAll();
            docRef.selection.copy(true);//"true" copies merged  layers
            //add the new channel
            var chanRef = docRef.channels.add();
            chanRef.name = layerName;
            docRef.paste();
		}   
		//delete the layer
		layerRef.remove();
		//cleanup when finished
		if(i == groupLength - 1){
            docRef.activeLayer.remove();
            docRef.selection.deselect();
            app.purge(PurgeTarget.CLIPBOARDCACHE);
            alert("Done! \nRemember to pay Jeremy $1 every time you use this ;-)");
		}
	}
}
else{
	alert("You have to have a Group selected.");
}

//checks to see if there is a selection on the document
function checkSelection(document){
	var mode = app.displayDialogs;
	var res = false;
	try{
        app.displayDialogs = DialogModes.NO;
        document.selection.load(docRef.channels[0], SelectionType.REPLACE);//0 = red, 1 = green, 2 = blue
        document.selection.contract(0);
        res = true;
	}
    catch(e){
	}
    finally{
        document.selection.deselect();
        app.displayDialogs = mode;
	}
	return res;
}